--a pitiful attempt at creating a Raycasting system to render the Red Room in the Black Lodge
--window size is 960x640

function love.load()
	CELL_S = 32
	SCREEN = love.window.setMode(960, 600)
	map_height = 14
	map_width = 19
	GAME_MAP = map_create(map_width, map_height)

	player_x = 500
	player_y = 300
	playerw = 10
	playerh = 10

	player_angle = math.rad(135)
	check_angle = player_angle

	--naming these now so the rays can later be drawn with love.graphics.line
	hrayEndx = 0
	hrayEndy = 0
	vrayEndx = 0
	vrayEndy = 0
end

function love.update(dt)
	--player movement with collision checks
	if love.keyboard.isDown('down') then
		player_y = player_y + 50 * dt
		if GAME_MAP[math.floor(player_x/CELL_S)][math.floor((player_y+playerh)/CELL_S)] == 1 then
			player_y = player_y - 50 * dt
		end
	end
	if love.keyboard.isDown('up') then
		player_y = player_y - 50 * dt
		if GAME_MAP[math.floor(player_x/CELL_S)][math.floor(player_y/CELL_S)] == 1 then
			player_y = player_y + 50 * dt
		end
	end
	if love.keyboard.isDown('left') then
		player_x = player_x - 50 * dt
		if GAME_MAP[math.floor(player_x/CELL_S)][math.floor(player_y/CELL_S)] == 1 then
			player_x = player_x + 50 * dt
		end
	end
	if love.keyboard.isDown('right') then
		player_x = player_x + 50 * dt
		if GAME_MAP[math.floor((player_x+playerw)/CELL_S)][math.floor(player_y/CELL_S)] == 1 then
			player_x = player_x - 50 * dt
		end
	end

	--check for horizontal intersection, beginning with grid offset
	checking = 1
	tileX = x_quadrant_sign(check_angle)
	tileY = y_quadrant_sign(check_angle)

	if tileY == -1 then
		A_y = math.floor(player_y/CELL_S) * CELL_S - 1
	else
		A_y = math.floor(player_y/CELL_S) * CELL_S + CELL_S
	end
	A_x = player_x + ((player_y - A_y)/math.tan(check_angle))

	Ya = tileY * CELL_S
	Xa = CELL_S/math.tan(check_angle)

	hrayEndx = A_x
	hrayEndy = A_y

	-- TODO this doesn't work
	if check_angle == math.rad(180) then
		hrayEndx = 0
		hrayEndy = player_y
	elseif check_angle == math.rad(0) then
		hrayEndx = 960
		hrayEndy = player_y 
	else
		while (GAME_MAP[math.floor(hrayEndx/CELL_S)][math.floor(hrayEndy/CELL_S)] == 0) and checking == 1 do
			--test using math.rad(15) degrees, it shows all the issues
				hrayEndx = hrayEndx + Xa
				hrayEndy = hrayEndy + Ya
				if math.floor((hrayEndx)/CELL_S) < 0 or math.floor((hrayEndx)/CELL_S) > map_width or 
					math.floor((hrayEndy)/CELL_S) < 0 or math.floor((hrayEndy)/CELL_S) > map_height then
					hrayEndx = hrayEndx - Xa
					hrayEndy = hrayEndy - Ya
					checking = 0
				end
		end
	end
	check_angle = check_angle + 0.2 * dt
	if check_angle < math.rad(0) then
		check_angle = math.rad(360)
	elseif check_angle > math.rad(360) then
		check_angle = math.rad(0)
	end
end





function love.draw()
	love.graphics.setColor(1,0,0)	
	for x=0,map_width do
		for y=0,map_height do
			if GAME_MAP[x][y] == 0 then
				love.graphics.setColor(.5,.5,.5)	
			elseif GAME_MAP[x][y] == 1 then
				love.graphics.setColor(1,0,0)
			end
			love.graphics.rectangle("fill", x*CELL_S, y*CELL_S, 30, 30)
		end
	end


	love.graphics.setColor(0,1,0)
	PLAYER = love.graphics.rectangle("fill", player_x, player_y, playerw, playerh)

	--the ray which checks h intersections
	love.graphics.setColor(1,1,0)
	love.graphics.line(player_x + (playerw/2), player_y + (playerh/2), hrayEndx, hrayEndy)
end






function map_create()
-- thinking out loud here. make the world grid a two dimensional array following basic coordinates in range(0,MAP_X and MAP_Y)
-- then while tracing the ray divide by 32 and floor the result to see which grid square it falls under

--creates a map grid with walls on all four sides
--y is first then x
	map = {map_width, map_height}
	for x=0,map_width do
		map[x] = {}
		for y=0,map_height do
			map[x][y] = 0
		end
	end

	for x=0,map_width do
		map[x][0] = 1
		map[x][map_height] = 1 
	end
	for y=0,map_height do
		map[0][y] = 1
		map[map_width][y] = 1
	end
	map[4][1] = 1
	map[4][2] = 1
	return map
end

function x_quadrant_sign(check_angle)
	if check_angle <= math.rad(90) and check_angle >= math.rad(270) then
		tileX = -1
	else 
		tileX = 1
	end
	return tileX
end

function y_quadrant_sign(check_angle)
	if check_angle >= math.rad(0) and check_angle <= math.rad(180) then
		tileY = -1
	else 
		tileY = 1
	end
	return tileY
end


-- --another bound check
--  and
-- 			hrayEndx + Xa >= 0 and hrayEndx <= 960 and hrayEndy >= 0 and hrayEndy <= 600 

-- math.floor((hrayEndx)/CELL_S) < 0 or math.floor((hrayEndx)/CELL_S) > map_width or
-- 				math.floor((hrayEndy)/CELL_S) < 0 or math.floor((hrayEndy)/CELL_S) > map_height